"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _react2 = require("@formily/react");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getValue = function getValue(data) {
  if (Array.isArray(data)) {
    if (data && data.length) {
      return data[0].value;
    }

    return '';
  }

  return data;
};
/**
 * 1. 等待筛选框相关异步请求返回
 * 2. 获取返回数据，并取第一个值
 * 3. 将入参带入 query
 */


var useAsyncDefaultPlugin = function useAsyncDefaultPlugin(options) {
  var asyncDefaultRef = (0, _react.useRef)({});
  return {
    middlewares: function middlewares(ctx, next) {
      var query = options.query,
          field = options.field,
          _options$isDefault = options.isDefault,
          isDefault = _options$isDefault === void 0 ? true : _options$isDefault,
          _options$setDefaultVa = options.setDefaultValue,
          setDefaultValue = _options$setDefaultVa === void 0 ? getValue : _options$setDefaultVa;
      var actions = ctx.actions,
          methods = ctx.methods,
          meta = ctx.meta;
      var queryFrom = meta.queryFrom;

      if ([methods.ON_MOUNT, methods.ON_FORM_MOUNT].includes(queryFrom)) {
        var queries;
        var fields;

        if (!Array.isArray(query)) {
          queries = [query];
          fields = [field];
        } else {
          queries = query;
          fields = field;
        }

        return Promise.all(queries.map(function (q) {
          return q();
        })).then(function (res) {
          var initialValues = fields.reduce(function (values, name, $index) {
            var data = res[$index].data;
            return _objectSpread(_objectSpread({}, values), {}, _defineProperty({}, name, setDefaultValue(data, name)), ctx.params);
          }, {});

          if (isDefault) {
            ctx.params = _objectSpread(_objectSpread({}, initialValues), ctx.params);
            actions.setFormState(function (state) {
              var _actions$getFormState = actions.getFormState(),
                  values = _actions$getFormState.values;

              state.initialValues = _objectSpread(_objectSpread({}, values), initialValues);
              asyncDefaultRef.current = state.initialValues;
            });
          }

          return actions.setFieldState(_react2.FormPath.match("*(".concat(fields.join(','), ")")), function (state) {
            var $res = res[fields.indexOf(state.name)];
            var data = $res.data;

            if (isDefault) {
              state.value = initialValues[state.name];
            }

            state.value = initialValues[state.name];
            state.props.enum = data;
          });
        }).then(next);
      }

      ctx.params = _objectSpread(_objectSpread({}, asyncDefaultRef.current), ctx.params);
      return next();
    }
  };
};

var _default = useAsyncDefaultPlugin;
exports.default = _default;